<?php 
class PMillImager {
	function get_full_img_path( $file ) {
		// Determine WP path
		$parse_site_url = parse_url( get_site_url() );
		$site_folder = $parse_site_url['path'];
		$site_path = ( empty( $site_folder ) ) ? dirname(WP_CONTENT_DIR) : dirname(dirname(WP_CONTENT_DIR));
		$parse_file_url = parse_url( $file );
		$img_path = $parse_file_url['path'];

		// Build image path
		return $site_path.$img_path;
	}

	function hex2rgb($hex) {
	   $hex = str_replace("#", "", $hex);

	   if(strlen($hex) == 3) {
	      $r = hexdec(substr($hex,0,1).substr($hex,0,1));
	      $g = hexdec(substr($hex,1,1).substr($hex,1,1));
	      $b = hexdec(substr($hex,2,1).substr($hex,2,1));
	   } else {
	      $r = hexdec(substr($hex,0,2));
	      $g = hexdec(substr($hex,2,2));
	      $b = hexdec(substr($hex,4,2));
	   }
	   $rgb = array($r, $g, $b);
	   //return implode(",", $rgb); // returns the rgb values separated by commas
	   return $rgb; // returns an array with the rgb values
	}

	function spp_isim_create_img( $args ) {
	// Check if required libraries are installed
	$req = new PMillPluginReq();

	if( $req->GDCheck() == 1 && $req->FreetypeCheck() == 1 ) {
		// Get options
		$this->options = get_option( 'spp_isim_options' );
		// Get image path
		$custombg_path = $this->get_full_img_path( $this->options['custombg'] );

		// Setup Image Details
		$defBGimg = ( isset( $args['usedfbg'] ) && empty( $this->options['custombg'] ) ) ? SPP_ISIM_PATH.'/modules/images/'.$this->options['defBGimg'].'.jpg' : $custombg_path ;
		$defBGimg = ( !empty( $args['singlecustombg'] ) ) ? $this->get_full_img_path( $args['singlecustombg'] ) : $defBGimg ;
		$tColor = $this->hex2rgb($args['textColor']);
		$wmtColor = $this->hex2rgb($args['wmtextColor']);
		$defBGimg_path = pathinfo($defBGimg);
		$filename = $defBGimg_path['filename'];
		$extension = $defBGimg_path['extension'];
		$uniqid = uniqid();
		$fontSize = $args['font_size'];
		$wmfontSize = $args['wmfont_size'];
		$break = $args['charbreak'];
		$angle = 0;
		$font = SPP_ISIM_PATH.'/modules/fonts/'.$args['font'].'.ttf';
		$wrappedContent = wordwrap( stripslashes($args['content']), $break, "\n" );
		$branding = stripslashes( $args['branding'] );

		if( ($extension == 'jpg') || ($extension == 'jpeg') ) {
			$bgImg = imagecreatefromjpeg($defBGimg);
		}
		if( $extension == 'gif' ) {
			$bgImg = imagecreatefromgif($defBGimg);
		}
		if( $extension == 'png' ) {
			$bgImg = imagecreatefrompng($defBGimg);
		}

		$tb = imagettfbbox($fontSize, 0, $font, $wrappedContent);
		$wmtb = imagettfbbox($wmfontSize, 0, $font, $branding);
		$imgSize = getimagesize( $defBGimg );
		$x = ceil( ( $imgSize[0] - $tb[2] ) / 2 );
		if( $args['position'] == 1 ) {
			$y = ceil( ($imgSize[1] - $tb[3]) * 0.2 );
		} elseif( $args['position'] == 2 ) {
			$y = ceil( ( $imgSize[1] - $tb[3] )* 0.8 );
		} else {
			$y =  ceil( ($imgSize[1] - $tb[3])  / 2 );
		}
		if( $args['wmtextAlign'] == 1) {
			$wmx = ceil( ( $imgSize[0] - $wmtb[2] ) / 2 );
		} elseif ( $args['wmtextAlign'] == 2 ) {
			$wmx = ceil( $imgSize[0] - ( $wmtb[2] + 10 ) );
		} else {
			$wmx = 10;			
		}		
		$wmy = $imgSize[1] - 10;
		$textColor = imagecolorallocate($bgImg, $tColor[0], $tColor[1], $tColor[2]);
		$wmtextColor = imagecolorallocate($bgImg, $wmtColor[0], $wmtColor[1], $wmtColor[2]);

		// Create text image
		imagettftext( $bgImg, $fontSize, $angle, $x, $y, $textColor, $font, $wrappedContent );
		imagettftext( $bgImg, $wmfontSize, 0, $wmx, $wmy, $wmtextColor, $font, $branding );
		// Save temp img
		if( ($extension == 'jpg') || ($extension == 'jpeg') ) {
			imagejpeg($bgImg, SPP_ISIM_PATH.'/modules/images/created/'.$uniqid.'-'.$filename.'.jpg');
		}
		if( $extension == 'gif' ) {
			imagepng($bgImg, SPP_ISIM_PATH.'/modules/images/created/'.$uniqid.'-'.$filename.'.png');
			$extension = 'png';
		}
		if( $extension == 'png' ) {
			imagepng($bgImg, SPP_ISIM_PATH.'/modules/images/created/'.$uniqid.'-'.$filename.'.png');
		}
		imagedestroy($bgImg);
		
		// Sideload to WP media library
		$upload_img = media_sideload_image(SPP_ISIM_DIR.'modules/images/created/'.$uniqid.'-'.$filename.'.'.$extension, $args['post_id']);
		echo '<div id="spp-isim-created-img-preview">'.$upload_img.'</div>';
		// Delete temp img
		unlink(SPP_ISIM_PATH.'/modules/images/created/'.$uniqid.'-'.$filename.'.'.$extension);
		//echo '<img src="'.SPP_ISIM_DIR.'modules/images/created/'.$uniqid.'-'.$filename.'.jpg" '.$imgSize[3].'>';
	}

	}
}
?>