<?php
/*
 * Add buttons to visual editor
 */
add_action( 'admin_head', 'spp_isim_tmcebuttons' );
function spp_isim_tmcebuttons($post) {	
	// Don't bother if current user doesn't have permissions
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
	
	// Add only in rich editor mode
	if( get_user_option( 'rich_editing' ) == 'true' ) {
		global $typenow;
            if (empty($typenow) && !empty($_GET['post'])) {
                $post = get_post($_GET['post']);
                $typenow = $post->post_type;
			} elseif (empty($typenow) && !empty($_GET['post_type'])) {
                $typenow = $_GET['post_type'];
			}
	}
	//if( 'spp_elp_sales' == $typenow || 'spp_elp_optin' == $typenow ) {
		add_filter('mce_external_plugins', 'spp_isim_buttons_mce_plugin');
		add_filter( 'mce_buttons', 'spp_isim_add_tmce_buttons' );
	//}
}

function spp_isim_add_tmce_buttons( $buttons ) {
    array_push( $buttons, '|', 'sppisimbuttons' );
    return $buttons;
}

/*
 * Bring in button
 */
 function spp_isim_buttons_mce_plugin( $plugins ) {
 	$wpversion = get_bloginfo( 'version' );
	// this plugin file will work the magic of our button
	//if( $wpversion > '3.8.1' ) {	
		$plugins['sppisimbuttons'] = SPP_ISIM_DIR . 'modules/js/tinymce-dialog.js';
	//} else {
	//	$plugins['sppisimbuttons'] = SPP_ISIM_DIR . 'modules/js/spp-jopt-shortcode-dialog-3.0.js';
	//}
		return $plugins;
	}

// Hook in TinyMCE dialog
add_action ( 'admin_footer', 'spp_isim_main_editor_dialog' );
function spp_isim_main_editor_dialog() {
	global $spp_isim_opts;
	global $post;
	$currScreen = get_current_screen();
	if( $currScreen -> parent_base == 'edit' ) {
	?>
	<div id="spp_isim_main_editor_dialog" class="dialog">
		<div id="spp-isim-createdimg">
		</div>
	<form id="spp-isim-create">
		<table>
			<tr>
				<th>Use default background</th>
				<td>
					<p><input type="checkbox" name="usedfbg" value="1" id="spp-isim-usedfbg" checked></p>
				</td>
			</tr>
			<tr>
				<th>Override default image</th>
				<td><a href="#" class="spp-isim-open-media button button-primary">Upload new</a> <small>(jpg or png only)</small><br><input type="text" name="singlecustombg" class="regular-text" id="spp-isim-custom-bg" value=""></td>
			</tr>
			<tr>
				<th>Text on image</th>
				<td>
					<textarea name="content" id="spp-isim-content" cols="30" rows="5"></textarea>
				</td>
			</tr>
			<tr>
				<th>Font type</th>
				<td>
					<ul class="spp-isim-font">
						<li id="craftygirls"><label>Crafty Girls<br><input type="radio" name="font" value="CraftyGirls" <?php checked( $spp_isim_opts['font'], 'CraftyGirls', true ); ?>></label></li>
						<li id="dancingscript"><label>Dancing Script<br><input type="radio" name="font" value="DancingScript-Regular" <?php checked( $spp_isim_opts['font'], 'DancingScript-Regular', true ); ?>></label></li>
						<li id="lobster"><label>Lobster<br><input type="radio" name="font" value="Lobster" <?php checked( $spp_isim_opts['font'], 'Lobster', true ); ?>></label></li>
						<li id="oswald"><label>Oswald<br><input type="radio" name="font" value="Oswald-Regular" <?php checked( $spp_isim_opts['font'], 'Oswald-Regular', true ); ?>></label></li>
						<li id="pacifico"><label>Pacifico<br><input type="radio" name="font" value="Pacifico" <?php checked( $spp_isim_opts['font'], 'Pacifico', true ); ?>></label></li>
						<li id="playfairdisplay"><label>Playfair Display<br><input type="radio" name="font" value="PlayfairDisplay-Regular" <?php checked( $spp_isim_opts['font'], 'PlayfairDisplay-Regular', true ); ?>></label></li>
						<li id="pt_sans_narrow"><label>PT Sans Narrow<br><input type="radio" name="font" value="PT_Sans-Narrow-Web-Bold" <?php checked( $spp_isim_opts['font'], 'PT_Sans-Narrow-Web-Bold', true ); ?>></label></li>
						<li id="raleway"><label>Raleway<br><input type="radio" name="font" value="Raleway-Bold" <?php checked( $spp_isim_opts['font'], 'Raleway-Bold', true ); ?>></label></li>
						<li id="shadowsintolight"><label>Shadows Into Light<br><input type="radio" name="font" value="ShadowsIntoLight" <?php checked( $spp_isim_opts['font'], 'ShadowsIntoLight', true ); ?>></label></li>
						<li id="specialelite"><label>Special Elite<br><input type="radio" name="font" value="SpecialElite" <?php checked( $spp_isim_opts['font'], 'SpecialElite', true ); ?>></label></li>
					</ul>
				</td>
			</tr>
			<tr>
				<th>Text options</th>
				<td>
					<label>Size: <input type="text" name="font_size" id="font_size" class="small-text" value="<?php if( !empty( $spp_isim_opts['font_size'] ) ) { echo stripslashes( $spp_isim_opts['font_size'] ); } ?>"></label>
					<label>Color: <input type="text" name="textColor" id="textColor" class="color-picker small-text" value="<?php if( !empty( $spp_isim_opts['textColor'] ) ) { echo stripslashes( $spp_isim_opts['textColor'] ); } ?>"></label><br>					
				</td>
			</tr>
			<tr>
				<td>Line break: </td>
				<th>
					<input type="text" name="charbreak" id="charbreak" class="small-text" value="<?php if( !empty( $spp_isim_opts['charbreak'] ) ) { echo stripslashes( $spp_isim_opts['charbreak'] ); } ?>"><br><small>Break text after this many characters</small>
				</th>
			</tr>
			<tr>
				<th>Text align</th>
				<td>
					<label>Top Align: <input type="radio" id="spp-isim-position" name="position" value="1" <?php checked( $spp_isim_opts['position'], '1', true ); ?>></label>
					<label>Middle Align: <input type="radio" id="spp-isim-position" name="position" value="0" <?php checked( $spp_isim_opts['position'], '0', true ); ?>></label>
					<label>Bottom Align: <input type="radio" id="spp-isim-position" name="position" value="2" <?php checked( $spp_isim_opts['position'], '2', true ); ?>></label>
				</td>
			</tr>
			<tr>
				<th>Branding</th>
				<td>
					<input type="text" name="branding" id="spp-isim-branding" class="regular-text" value="<?php if( !empty( $spp_isim_opts['branding'] ) ) { echo stripslashes( $spp_isim_opts['branding'] ); } ?>">
				</td>
			</tr>
			<tr>
				<th>Branding text options</th>
				<td>
					<label>Size: <input type="text" name="wmfont_size" id="wmfont_size" class="small-text" value="<?php if( !empty( $spp_isim_opts['wmfont_size'] ) ) { echo stripslashes( $spp_isim_opts['wmfont_size'] ); } ?>"></label>
					<label>Color: <input type="text" name="wmtextColor" id="wmtextColor" class="color-picker small-text" value="<?php if( !empty( $spp_isim_opts['wmtextColor'] ) ) { echo stripslashes( $spp_isim_opts['wmtextColor'] ); } ?>"></label>
				</td>
			</tr>
			<tr>
				<th>Branding text align</th>
				<td>
					<label>Left: <input type="radio" id="spp-isim-wmtextAlign" name="wmtextAlign" value="0" <?php checked($spp_isim_opts['wmtextAlign'], '0', true ); ?>></label>
					<label>Center: <input type="radio" id="spp-isim-wmtextAlign" name="wmtextAlign" value="1" <?php checked($spp_isim_opts['wmtextAlign'], '1', true ); ?>></label>
					<label>Right: <input type="radio" id="spp-isim-wmtextAlign" name="wmtextAlign" value="2" <?php checked($spp_isim_opts['wmtextAlign'], '2', true ); ?>></label>
				</td>
			</tr>
			<tr>
				<th></th>
				<td>
					<input type="hidden" name="post_id" id="spp-isim-post-id" value="<?php echo get_the_ID(); ?>">
					<input type="submit" name="createimg" id="createimg" class="button-primary" value="Create Image">
				</td>
			</tr>
		</table>
	</form>
	</div>
	<?php
	}
}

// Ajax process for TinyMCE editor popup
add_action( 'wp_ajax_spp_isim_do_ajax_request', 'spp_isim_process_ajax_inline' );
function spp_isim_process_ajax_inline() {
	// Verify
	if( !isset( $_POST['nonce'] ) || !wp_verify_nonce( $_POST['nonce'], 'spp-isim-create' ) )
		die( 'Nonce not present or valid' );
	if( $_POST['is_admin'] != true )
		die( 'You do not have admin privileges to perform this action' );

	$img = new PMillImager();
	$img->spp_isim_create_img( $_POST );
	?>
	<script> 
	jQuery(document).ready( function($){
		$('#spp-isim-again').on('click', function(e) {
			e.preventDefault();
			$('form#spp-isim-create').show();
			$('#spp-isim-createdimg').hide();
		});
		$('#spp-isim-delete').on('click', function(e) {
			e.preventDefault();
			var img_url = $('#spp-isim-created-img-preview img').attr('src');
			console.log(img_url);
			data = {
			action: 'spp_isim_remove_ajax_request',
			img_url: img_url
			};
			$.post(ajaxurl, data, function(response) {
				//alert(response);
				$('#spp-isim-createdimg').show();
				$('#spp-isim-createdimg').html(response);
			})
			return false;
		});
		$('#spp-isim-insert').on('click', function(e) {
			e.preventDefault();
			var created_img = $('#spp-isim-created-img-preview').html();
			//console.log(created_img);
			tinymce.activeEditor.execCommand('mceInsertContent', false, created_img);
			top.tinymce.activeEditor.windowManager.close();
		});
	}); // global end
	</script>
	<ul>
		<li><button id="spp-isim-again" class="button-secondary">Create Another</button></li>
		<li><button id="spp-isim-delete" class="button-secondary">Delete Image</button></li>
		<li><button id="spp-isim-insert" class="button-secondary">Insert Into Editor</button></li>
	</ul>
	<?php
	// Don't forget this or you'll get a 0 added to response
	die();
}

add_action( 'wp_ajax_spp_isim_remove_ajax_request', 'spp_isim_remove_image' );
function spp_isim_remove_image() {
	$attachment_id = get_attachment_id_from_src( esc_url( $_POST['img_url'] ) );
	//echo 'Att id: '.$attachment_id;
	wp_delete_attachment( $attachment_id, true );
	?>
	<script>
	jQuery(document).ready( function($){
			$('form#spp-isim-create').show();
			$('#spp-isim-createdimg').hide();
	});
	</script>
	<?php
	exit();
}

function get_attachment_id_from_src ($image_src) {
		global $wpdb;
		$query = "SELECT ID FROM {$wpdb->posts} WHERE guid='$image_src'";
		$id = $wpdb->get_var($query);
		return $id;
	}
?>